part of snowm_scanner;

class TelemetryPacket {
  TelemetryPacket({
    this.rawData,
    this.uuid,
    this.battery,
  });

  String rawData, uuid = "TBD", macAddress;
  int battery = 0;

  static TelemetryPacket _parse(args) {
    String rawData = args["rawData"];
    print(rawData);
    TelemetryPacket packet = TelemetryPacket()..rawData = rawData;
    String battery = getBattery(rawData);
    packet.battery = convertHexToDecimal(battery);
    packet.macAddress = getMacFromRAW(rawData);
    packet.uuid = asciiToHex(getUUIDFromMac(packet.macAddress));
    return packet;
  }
}

String _hexStringtoAscii(String hexString) {
  List<String> splitted = [];
  for (int i = 0; i < hexString.length; i = i + 2) {
    splitted.add(hexString.substring(i, i + 2));
  }
  String ascii = List.generate(splitted.length,
      (i) => String.fromCharCode(int.parse(splitted[i], radix: 16))).join();

  return ascii;
}

String asciiToHex(String value) {
  return value.characters.map((e) => e.codeUnitAt(0).toRadixString(16)).join();
}

String getBattery(String raw) {
  return raw.substring(34, 36);
}

int convertHexToDecimal(String str) {
  return int.parse(str, radix: 16);
}

String getUUIDFromMac(String mac) {
  return ("STSF" + mac).toUpperCase();
}

String getMacFromUUID(String uuid) {
  String ascii = _hexStringtoAscii(uuid);
  return ascii.replaceAll("STSF", "");
}

String getMacFromRAW(String raw) {
  return raw.substring(14, 26).toUpperCase();
}
